import { system, world, ItemStack} from "@minecraft/server";
import { ModalFormData, ActionFormData } from "@minecraft/server-ui";
let world = world.getDimension("overworld")

//EEVEE
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("eevee_interact")){
            eevee_interact(player)
			player.removeTag("eevee_interact")
		}
  }
  function eevee_interact (player) {
    const gui = new ActionFormData();
    gui.button('Follow Me!','textures/gui/menu/follow_me_icon')
    gui.button('Jump Up!', 'textures/gui/menu/jump_up_icon')
    gui.button('Go Dig!', 'textures/gui/menu/go_dig_icon')
    gui.button('Attack!', 'textures/gui/menu/attack_icon')
    gui.button('Evolve!', 'textures/gui/menu/evolve_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            follow_me(player)
        }
        if (result.selection === 1) {
            jump_up(player)
        }
        if (result.selection === 2) {
            go_dig(player)
        }
        if (result.selection === 3) {
            attack(player)
        }
        if (result.selection === 4) {
            evolve(player)
        }
        if (result.selection === 5) {
            exit(player)
        }
    }
)
}
function follow_me(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_default");
}
function jump_up(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_jump_up");
}
function go_dig(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_go_dig");
}
function attack(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_attack");
}
function evolve (player) {
    const gui = new ActionFormData();
    gui.body('Choose an evolution for your Eevee!');
    gui.button('Vaporeon!', 'textures/gui/menu/pokemon_icons/vaporeon_icon')
    gui.button('Jolteon!', 'textures/gui/menu/pokemon_icons/jolteon_icon')
    gui.button('Flareon!', 'textures/gui/menu/pokemon_icons/flareon_icon')
    gui.button('Espeon!', 'textures/gui/menu/pokemon_icons/espeon_icon')
    gui.button('Umbreon!', 'textures/gui/menu/pokemon_icons/umbreon_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("vaporeon_evolve")) {
            vaporeon_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("vaporeon_evolve")) {
            vaporeon_denied(player)
        }
        if (result.selection === 1 && player.hasTag("jolteon_evolve")) {
            jolteon_confirm(player)
        }
        if (result.selection === 1 && !player.hasTag("jolteon_evolve")) {
            jolteon_denied(player)
        }
        if (result.selection === 2 && player.hasTag("flareon_evolve")) {
            flareon_confirm(player)
        }
        if (result.selection === 2 && !player.hasTag("flareon_evolve")) {
            flareon_denied(player)
        }
        if (result.selection === 3 && player.hasTag("espeon_evolve")) {
            espeon_confirm(player)
        }
        if (result.selection === 3 && !player.hasTag("espeon_evolve")) {
            espeon_denied(player)
        }
        if (result.selection === 4 && player.hasTag("umbreon_evolve")) {
            umbreon_confirm(player)
        }
        if (result.selection === 4 && !player.hasTag("umbreon_evolve")) {
            umbreon_denied(player)
        }
        if (result.selection === 5) {
            exit(player)
        }
    }
)
}
function vaporeon_confirm (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to evolve your Eevee into a Vaporeon?');
    gui.button('Yes!', 'textures/gui/menu/confirm_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            vaporeon_confirmed(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function vaporeon_confirmed(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_vaporeon");
    player.runCommandAsync("clear @s true:water_stone 0 1");
    player.runCommandAsync("xp -25l @s");
}
function vaporeon_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this evolution!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function jolteon_confirm (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to evolve your Eevee into a Jolteon?');
    gui.button('Yes!', 'textures/gui/menu/confirm_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            jolteon_confirmed(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function jolteon_confirmed(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_jolteon");
    player.runCommandAsync("clear @s true:thunder_stone 0 1");
    player.runCommandAsync("xp -25l @s");
}
function jolteon_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this evolution!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function flareon_confirm (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to evolve your Eevee into a Flareon?');
    gui.button('Yes!', 'textures/gui/menu/confirm_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            flareon_confirmed(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function flareon_confirmed(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_flareon");
    player.runCommandAsync("clear @s true:fire_stone 0 1");
    player.runCommandAsync("xp -25l @s");
}
function flareon_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this evolution!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function espeon_confirm (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to evolve your Eevee into an Espeon?');
    gui.button('Yes!', 'textures/gui/menu/confirm_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            espeon_confirmed(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function espeon_confirmed(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_espeon");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
    player.runCommandAsync("xp -25l @s");
}
function espeon_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this evolution!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function umbreon_confirm (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to evolve your Eevee into an Umbreon?');
    gui.button('Yes!', 'textures/gui/menu/confirm_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            umbreon_confirmed(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function umbreon_confirmed(player) {
    player.runCommandAsync("event entity @e [family=eevee,c=1,r=5] true:to_umbreon");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
    player.runCommandAsync("xp -25l @s");
}
function umbreon_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this evolution!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//VAPOREON
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vaporeon_interact")){
            vaporeon_interact(player)
			player.removeTag("vaporeon_interact")
		}
  }
  function vaporeon_interact (player) {
    const gui = new ActionFormData();
    gui.button('Follow Me!','textures/gui/menu/follow_me_icon')
    gui.button('Attack!', 'textures/gui/menu/attack_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            follow_me(player)
        }
        if (result.selection === 1) {
            attack(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function follow_me(player) {
    player.runCommandAsync("event entity @e [family=vaporeon,c=1,r=5] true:to_default");
}
function attack(player) {
    player.runCommandAsync("event entity @e [family=vaporeon,c=1,r=5] true:to_attack");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//JOLTEON
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("jolteon_interact")){
            jolteon_interact(player)
			player.removeTag("jolteon_interact")
		}
  }
  function vaporeon_interact (player) {
    const gui = new ActionFormData();
    gui.button('Follow Me!','textures/gui/menu/follow_me_icon')
    gui.button('Attack!', 'textures/gui/menu/attack_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            follow_me(player)
        }
        if (result.selection === 1) {
            attack(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function follow_me(player) {
    player.runCommandAsync("event entity @e [family=jolteon,c=1,r=5] true:to_default");
}
function attack(player) {
    player.runCommandAsync("event entity @e [family=jolteon,c=1,r=5] true:to_attack");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//FLAREON
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("flareon_interact")){
            flareon_interact(player)
			player.removeTag("flareon_interact")
		}
  }
  function flareon_interact (player) {
    const gui = new ActionFormData();
    gui.button('Follow Me!','textures/gui/menu/follow_me_icon')
    gui.button('Attack!', 'textures/gui/menu/attack_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            follow_me(player)
        }
        if (result.selection === 1) {
            attack(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function follow_me(player) {
    player.runCommandAsync("event entity @e [family=flareon,c=1,r=5] true:to_default");
}
function attack(player) {
    player.runCommandAsync("event entity @e [family=flareon,c=1,r=5] true:to_attack");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ESPEON
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("espeon_interact")){
            espeon_interact(player)
			player.removeTag("espeon_interact")
		}
  }
  function espeon_interact (player) {
    const gui = new ActionFormData();
    gui.button('Follow Me!','textures/gui/menu/follow_me_icon')
    gui.button('Attack!', 'textures/gui/menu/attack_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            follow_me(player)
        }
        if (result.selection === 1) {
            attack(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function follow_me(player) {
    player.runCommandAsync("event entity @e [family=espeon,c=1,r=5] true:to_default");
}
function attack(player) {
    player.runCommandAsync("event entity @e [family=espeon,c=1,r=5] true:to_attack");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//UMBREON
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("umbreon_interact")){
            umbreon_interact(player)
			player.removeTag("umbreon_interact")
		}
  }
  function umbreon_interact (player) {
    const gui = new ActionFormData();
    gui.button('Follow Me!','textures/gui/menu/follow_me_icon')
    gui.button('Attack!', 'textures/gui/menu/attack_icon')
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            follow_me(player)
        }
        if (result.selection === 1) {
            attack(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function follow_me(player) {
    player.runCommandAsync("event entity @e [family=umbreon,c=1,r=5] true:to_default");
}
function attack(player) {
    player.runCommandAsync("event entity @e [family=umbreon,c=1,r=5] true:to_attack");
}
function exit(player) {
    player.runCommandAsync;
  }
})